/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package applet;

import java.awt.AWTEvent;
import java.awt.Button;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.TextComponent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import matcher.TibiListener;

public class ButtonBar extends Container {
	
	TextComponent text;
	Label status;
	Button buttons[];
	
	class Mausi extends MouseAdapter {
		WritingCanvas canvas;
		int n;
		Mausi (int n, WritingCanvas canvas) {
			this.canvas= canvas;
			this.n=n;
		}
		public void mousePressed(MouseEvent e) {
			text.setText(text.getText()+buttons[n].getLabel());
			canvas.clear();
		}
	}
	
	public ButtonBar(TextComponent text, WritingCanvas canvas, int n) {
		this.text=text;
		setLayout(new GridLayout(1,4));		
		buttons= new Button[n];
		for (int i=0; i<n; ++i) {
			buttons[i]= new Button("   ");
			buttons[i].addMouseListener(new Mausi(i, canvas));
			add(buttons[i]);
		}
	}
	
	public void clear() {
		for (int i=0; i<buttons.length; ++i) {
			buttons[i].setLabel("");
		}
	}

	public void setResult(int n, String value) {
		if (n<buttons.length)
			if (value==null)
				buttons[n].setLabel("");
			else
				buttons[n].setLabel(value);
	}
}
