/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package applet;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import parser.RuleSetReader;

import rules.RuleSet;

import matcher.ParameterSet;

public class TibiFrame {
	
	TibiFrame() {
		start();
	}
	
    void start() {
    	// Create a frame
	    String title = "Tibi";
	    Frame frame = new Frame(title);
	    
	    RuleSet rules;
	    try {
	    	rules= RuleSetReader.readFile("pattern.txt");
	    } catch (Exception e) {
	    	e.printStackTrace();
	    	rules=new RuleSet();
	    }
	    frame.add(new TibiComponent(rules));
	    // Show the frame;
	    frame.setSize(300, 450);
	    frame.pack();
	    frame.setVisible(true);	  
	    //frame.setAlwaysOnTop(true);
	    
	    // Add a listener for the close event
	    frame.addWindowListener(new WindowAdapter() {
	        public void windowClosing(WindowEvent evt) {
	            // Exit the application
	            System.exit(0);
	        }
	    });	    	    
	}
	
	public static void main(String args[]) {
    	ParameterSet.verbose=false;
    	ParameterSet.tryVariations=true;
    	ParameterSet.permuteStrokeOrder=true;
    	ParameterSet.reverseStroke=true;
		new TibiFrame();
		if (args.length >0 && args[0].equals("kill"))
			System.exit(0);
	}
}
