/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package matcher;

public class ParameterSet {
	
	// length and decays
	public static double locatorRangeDecay= 6.0;
	public static double minimalStrokeLength= 0.02;
	public static double minimalFirstStrokeLength= 0.05;
	public static double considerIgnoreStrokeLength= 0.05;
	public static double maximumInitialJunk= 0.3;
	
	// multiplied costs
	public static double skippedStroke=0.9;
	public static double missingSuffix=0.9;
	public static double missingPrefix=0.9;
	public static double reversedStroke=0.7;
	public static double unmatchedStroke=0.0;
	
	// Basis of power functions
	public static double redundantStroke=0.2;
	public static double lineBreak= 0.1;
	
	// switches
	public static boolean verbose= true;
	public static boolean tryVariations= true;
	public static boolean reverseStroke= true;
	public static boolean permuteStrokeOrder= false;
	
	//fittness treshholds
	public static double worstSecondBest= 0.5;
	public static double minimumFit=0.1;
}
