/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package nodes;

import java.text.DecimalFormat;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Vector;

public final class NodeList {
	
	Vector<Node[]> nodes;
	Collection<Node> stroke;
	
	public NodeList() {
		nodes= new Vector<Node[]>();
	}

	public void startStroke() {
		stroke=new LinkedList<Node>();
	}
	
	public void endStroke(Vector2d p) {
		if (stroke.size()>0) {
			add(p, 0);
			nodes.add(new Node[stroke.size()]);
			Iterator<Node> it=stroke.iterator();
			for (int i=0; i<stroke.size(); ++i)
				nodes.lastElement()[i]=it.next();
		}
		stroke= null;
	}
	
	public void add(Vector2d p, int type) {
		stroke.add(new Node(p,type));
	}
	
	public void add(double x, double y, int type) {
		stroke.add(new Node(x,y,type));
	}
	
	public String toString() {
		StringBuffer buf= new StringBuffer();
		for (Node[] v:nodes) {
			for (Node n : v) {
				buf.append(n.toString());
				if (n.typeset==0)
					buf.append(". ");
				buf.append(" ");
			}
			buf.append(" ");
		}
		return buf.toString();
	}
}
