/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package nodes;

public class Vector2d {
	public double x;
	public double y;

	public Vector2d() {}
	
	public Vector2d(double x, double y) {
		set(x,y);
	}

	public Vector2d(Vector2d vec) {
		set(vec.x, vec.y);
	}
	
	public void set(double x, double y) {
		this.x=x;
		this.y=y;		
	}
	
	public void set(Vector2d vec) {
		x= vec.x;
		y= vec.y;
	}
	
	public double length() {
		return Math.sqrt(x*x+y*y);
	}
	
	public void scale(double s) {
		x*=s;
		y*=s;
	}
	
	public void sub(Vector2d vec) {
		x-=vec.x;
		y-=vec.y;
	}
	
	public void add(Vector2d vec) {
		x+=vec.x;
		y+=vec.y;
	}
}
