package parser;

import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;

import rules.RuleSet;

public class RuleSetReader {

	static public RuleSet readURI(String location) throws Exception {
		return read(new URL(location).openStream());
	}
	
	static public RuleSet readFile(String filename) throws Exception {
		return read(new FileInputStream(filename));
	}
	
	static public RuleSet read(InputStream input) throws Exception {
		Reader in = new InputStreamReader(input, "UTF-8");
	    parser p = new parser(new Lexer(in));
	    Object result = p.parse().value;  
	    return (RuleSet) result;
	}
}


