/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package rules;

import java.util.Collection;
import java.util.LinkedList;
import java.lang.StringBuffer;

public abstract class Pattern {
	
	LinkedList<Locator> locators;
	
	public Pattern() {
	}
	
	public void addLocator(Locator locator) {
		if (locators==null)
			locators= new LinkedList<Locator>();
		locators.add(locator);
	}
		
	public Collection<Locator> locators() {
		return locators;
	}
	
	public String locatorString() {
		StringBuffer buf= new StringBuffer();
		if (locators!=null)
			for (Locator loc : locators)	
				buf.append(loc.toString());
		return buf.toString();
	}
}
