/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package rules;

public class Rule {

	GroupPattern pattern;
	String target;
	boolean visible;
	int line;
	
	public Rule(String target, GroupPattern pattern) {
		this.target= target;
		this.pattern= pattern;
		visible= true;
	}

	public Rule(String target, GroupPattern pattern, boolean visible) {
		this.target= target;
		this.pattern= pattern;
		this.visible= visible;
	}
	
	public Pattern getPattern() {
		return pattern;
	}
	
	public String getTarget() {
		return target;
	}
	
	public void setLineNumber(int linenumber) {
		line= linenumber;
	}
	
	public int getLineNumber() {
		return line;
	}
	
	public boolean isVisible() {
		return visible;
	}
	
	public String toString() {
		return target + ":" + pattern;
	}
}
