/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package test;

import matcher.TibiListener;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class CharacterBar extends Canvas implements TibiListener {

	Text text;
	Button chars[];
	Display dis;
	static Label status;
	
	class CharSelectedListener implements MouseListener {
		int i;
		public CharSelectedListener(int j) { i=j; }
		public void mouseUp(MouseEvent e) {}
		public void mouseDown(MouseEvent e) { 
			TibiTestcaseManager.canvas.scanner.printContext(chars[i].getText());
			text.setText(text.getText() + chars[i].getText());
			chars[chars.length-1].setText(chars[i].getText());
			chars[chars.length-1].redraw();
			//TibiXiezi.canvas.clear();
		}
		public void mouseDoubleClick(MouseEvent e) {}								
	}
	
	public CharacterBar(Composite parent) {
		super(parent, SWT.NONE);
		dis= Display.getCurrent();
		
		RowLayout layout= new RowLayout(SWT.VERTICAL);
		layout.pack=true;
		layout.justify= false;
		layout.fill=true;
		setLayout(layout);
		text= new Text(this,SWT.SINGLE);

		Canvas canvas= new Canvas(this, SWT.NONE);
		RowLayout layout2= new RowLayout(SWT.HORIZONTAL);
		layout2.pack=false;
		layout2.fill=true;
		layout2.justify=true;
		layout2.marginBottom=1;
		layout2.marginTop=1;
		layout2.marginLeft=1;
		layout2.marginRight=1;
		canvas.setLayout(layout2);
		chars = new Button[7];
		for (int i=0; i<chars.length; i++) {
			chars[i]= new Button(canvas, SWT.FLAT);
			chars[i].setText("     ");
			chars[i].addMouseListener(new CharSelectedListener(i));
		}
		
		status= new Label(this, SWT.CENTER);
		status.setText("status");
	}
	
	class StatusThread implements Runnable {
		String message;
		StatusThread(String status) {
			message=status;
		}
		public void run() {
			status.setText(message);
			status.redraw();
		}
	}
	
	public void status (int type, String message) {
		switch(type) {
		case TibiListener.START:
			message="Searching...";
			break;
		case TibiListener.CLEAR:
		case TibiListener.FINISHED:
			message="";
			break;
		case TibiListener.STOP:
			message="stopped...";
			break;
		case TibiListener.ERROR:
			message="Error: "+message;
			break;
		}
		dis.asyncExec(new StatusThread(message));
	}
	
	public void clearAllResults() {
		dis.asyncExec(new Runnable() {
			public void run() {
				for (int i=0; i<chars.length-1; i++) {
				chars[i].setText("   ");
				chars[i].redraw();
			}}});
	}
	
	class SetResultThread implements Runnable {
		Button[] b;
		int i;
		String value;
		SetResultThread(Button b[], int i, String value) {
			this.b= b;
			this.i= i;
			if (value==null)
				this.value="   ";
			else
				this.value=value;
		}
		public void run() {
			try {
				b[i].setText(value);
				b[i].redraw();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	public void setResult(int i, String value) {
		Runnable run= new SetResultThread(chars, i,value);
		if (i<chars.length)
			dis.asyncExec(run);
	}
}
