/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package test;

import rules.MacroPattern;
import rules.Pattern;
import rules.PatternTraverser;
import rules.ReferencePattern;
import rules.Rule;
import rules.RuleSet;
import rules.StrokePattern;

public class PatternTraverserTest {

	static RuleSet rules;

	public static void testPatternTraverser() {
		for (Rule r : rules) {
			if (r.isVisible()) {
				System.out.println("Traversing: "+r);
				PatternTraverser tra= new PatternTraverser(r.getPattern());
				while(tra.hasNext()) {
					System.out.println(tra.isLastInGroup() + ": "+ tra.next());
				}
				System.out.println();
			}
		}
	}
	
	public static void testRadicalSearch() {
		for (Rule r : rules) {
			if (r.isVisible()) {
				PatternTraverser tra= new PatternTraverser(r.getPattern());
				String pseudoRadical=null;
				while(tra.hasNext()) {
					Pattern cur= tra.next();
					if (cur instanceof StrokePattern) {
						pseudoRadical= ((StrokePattern)cur).toString();
						break;
					}
					if (cur instanceof ReferencePattern && ! (cur instanceof MacroPattern)) {
						pseudoRadical= ((ReferencePattern)tra.current()).getName();
						pseudoRadical= "-> "+rules.getLineNumber(pseudoRadical);
						break;
					}
				}
				System.out.println(r.getLineNumber()+" : "+pseudoRadical);
			}
		}		
	}
	
	public static void main(String args[]) throws Exception {
		rules= parser.RuleSetReader.readFile("pattern.txt");
		testRadicalSearch();
	}
}
