/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package test;

import matcher.HanziScanner;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;

import parser.RuleSetReader;

import rules.RuleSet;


public class TibiXiezi {

	static CharacterBar charbar;
	static WritingCanvas canvas;
	static Display display;
	static Shell shell;
	static MessageBox dosave;
	static FailBrowser tests;
	static RuleSet rules;
	
	public static void main(String[] args) {
		
	    try {
	    	rules= RuleSetReader.readFile("pattern.txt");
	    } catch (Exception e) {
	    	rules= new RuleSet();
	    }
		
		display= new Display();
		shell= new Shell(display);
		shell.setText("Tibi Xiezi");
		shell.setSize(350,400);
		GridLayout layout= new GridLayout(4, false);
		shell.setLayout(layout);
		
		charbar= new CharacterBar(shell);
		GridData griddata1=new GridData(GridData.GRAB_HORIZONTAL | GridData.FILL_HORIZONTAL);
		griddata1.horizontalSpan=3;
		griddata1.verticalSpan=1;
		charbar.setLayoutData(griddata1);
		
		canvas= new WritingCanvas(shell);
		GridData griddata2=new GridData(GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
		griddata2.horizontalSpan=4;
		griddata2.verticalSpan=1;
		canvas.setLayoutData(griddata2);
		canvas.setRules(rules);
		
		dosave = new MessageBox(shell, SWT.ICON_QUESTION | SWT.OK | SWT.CANCEL); 


		Button button3= new Button(shell, SWT.PUSH);
		button3.setText("Reload");
		button3.addMouseListener(new MouseListener() {
			public void mouseUp(MouseEvent e) {}
			public void mouseDown(MouseEvent e) {
				try {
			    	rules= RuleSetReader.readFile("pattern.txt");
			    	canvas.setRules(rules);
			    	charbar.status.setText(rules.visibleRuleCount()+" rules loaded.");
				} catch (Exception x) {
					x.printStackTrace();
				}
			}
			public void mouseDoubleClick(MouseEvent e) {}				
		});

		Button button4= new Button(shell, SWT.PUSH);
		button4.setText("Test all");
		button4.addMouseListener(new MouseListener() {
			public void mouseUp(MouseEvent e) {}
			public void mouseDown(MouseEvent e) {
				try {
					if (tests.runtest()>0)
						tests.open();
				} catch (Exception x) {
					x.printStackTrace();
				}
			}
			public void mouseDoubleClick(MouseEvent e) {}				
		});

		Button button2= new Button(shell, SWT.PUSH);
		button2.setText("Clear");
		button2.addMouseListener(new MouseListener() {
			public void mouseUp(MouseEvent e) {}
			public void mouseDown(MouseEvent e) { canvas.clear(); }
			public void mouseDoubleClick(MouseEvent e) {}				
		});
		Button button1= new Button(shell, SWT.PUSH);
		button1.setText("Make Test");
		button1.addMouseListener(new MouseListener() {
			public void mouseUp(MouseEvent e) {}
			public void mouseDown(MouseEvent e) {
				String literal= charbar.chars[0].getText();
				dosave.setMessage("Create test case for character: "+literal);
				dosave.open();
				try {
					FailBrowser.store(literal, canvas.path);
				} catch (Exception x) {
					System.err.println("Writing failed.");
				}
			}
			public void mouseDoubleClick(MouseEvent e) {}				
		});
		
		tests= new FailBrowser(shell);
		/*
		if (tests.runtest()>0)
			tests.open();
			*/
		
		shell.open();		
		while(!shell.isDisposed()) {
		   // process the next event, wait when none available
		   if(!display.readAndDispatch()) {
		       display.sleep();
		   }
		}
	}

}
