/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package util;

import util.BiStack.Item;

public class BiBiStack<T> extends BiStack<BiStack<T>> {

	public BiBiStack() {
		super();
	}

	/** returns a deep copy up the second level.
	 * 
	 */
	public BiBiStack<T> copy() {
		BiBiStack<T> c= new BiBiStack<T>();
		c.count= count;
		c.up= up;
		c.down= down;

		Item dest, src;
		dest= null;
		src= up;
		while (src != null) {
			if (dest== null) {
				dest= new Item(src.entry.copy());
				c.up= dest;
			} else {
				dest.next= new Item(src.entry.copy());
				dest= dest.next;
			}
			src= src.next;
		}
		dest= null;
		src= down;
		while (src != null) {
			if (dest== null) {
				dest= new Item(src.entry.copy());
				c.down= dest;
			} else {
				dest.next= new Item(src.entry.copy());
				dest= dest.next;
			}
			src= src.next;
		}
		return c;
	}
}
