/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package util;

import java.util.Iterator;

public class BiStackIterator<T> implements Iterator<T> {
	
	BiStack<T>.Item item;
	
	public BiStackIterator(BiStack<T> stack){
		item= stack.up;
	}
	
	public T next() {
		T result= item.entry;
		item= item.next;
		return result;
	}

	public boolean hasNext() {
		return item!=null;
	}
	
	public void remove() throws UnsupportedOperationException {
		throw(new UnsupportedOperationException());
	}
}
