/* Tibi - Chinese handwriting recognition
 * Copyright (C) 2007 Stefan Dirnstorfer <stefan@dadim.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package util;

public class MessageStack extends BiStack<Object> {

	static final String nl= "\n";
	
	public MessageStack() {
	}
	
	public MessageStack copy() {
		MessageStack c= new MessageStack();
		c.count= count;
		c.up= up;
		c.down= down;
		return c;
	}

	public void message(Object... olist) {
		for (Object o : olist) {
			super.addFirst(o);
		}
		super.addFirst(nl);
	}
	
	public String toString() {
		String result="";
		for (Object o : this) {
			result= o + result;
		}
		return result;
	}
}
